#include <unistd.h>		// read(), close()
#include <fcntl.h>		// O_RDONLY
#include <sys/soundcard.h>	// AFMT_U8
#include <sound.h>
#include <iostream.h>
#include "sprec.h"

bool
crhit()
{
    char c;
    int numRead;

    fcntl( 0, F_SETFL, fcntl( 0, F_GETFL ) | O_NONBLOCK );
    numRead = read( 0, &c, 1 );
    fcntl( 0, F_SETFL, fcntl( 0, F_GETFL ) & ~O_NONBLOCK );
    
    if( numRead > 0 )
	ungetc( c, stdin );
    
    return numRead > 0;
}

int
main()
{
    int fAudio;
    
    if( ( fAudio = snd_initDevice( O_RDONLY, 11025, false, AFMT_U8 ) ) == -1 )
     {
	 snd_perror( "snd_initDevice" );
	 return -1;
     }

    CepstrumAnalyzer a;
    PatternDB pdb( "Testdb" );
    Sample buf = new unsigned char[11025*20];
    unsigned size;
    string name;

    cout << "Sprec learner\n\n";
    for( int i = 0; i < 5; ++i ) {
	cout << "\nenter name for pattern #" << i+1 << ": ";
	cin >> name;
	cout << "Speak word now... <return> to stop rec\n";
	size = 0;
	while( !crhit() && size < 11025*20) {
	    read( fAudio, buf+size, 256 );
	    size += 256;
	}
	cout << "Analyzing...\n";
	Pattern* p = a.Analyze( buf, size );
	p->SetName( name );
	pdb.Add( p );
    }
    
    close( fAudio );

    cout << "Saving pdb...\n";
    pdb.Save( "test.pdb" );
}

