#include <unistd.h>		// read(), close()
#include <fcntl.h>		// O_RDONLY
#include <sys/soundcard.h>	// AFMT_U8
#include <sound.h>
#include <iostream.h>
#include "sprec.h"

bool
crhit()
{
    char c;
    int numRead;

    fcntl( 0, F_SETFL, fcntl( 0, F_GETFL ) | O_NONBLOCK );
    numRead = read( 0, &c, 1 );
    fcntl( 0, F_SETFL, fcntl( 0, F_GETFL ) & ~O_NONBLOCK );
    
    if( numRead > 0 )
	ungetc( c, stdin );
    
    return numRead > 0;
}

int
main()
{
    cout << "Sprec recog\n\n";

	// load pdb
    PDBIOResult iores;
    PatternDB pdb( "test.pdb", iores );
    if( iores != PDB_OK ) {
	cout << "Error opening test.pdb!\n";
	return -1;
    }
    cout << "loaded test.pdb.\n";

	// init soundcard
    int fAudio;
    if( ( fAudio = snd_initDevice( O_RDONLY, 11025, false, AFMT_U8 ) ) == -1 )
     {
	 snd_perror( "snd_initDevice" );
	 return -1;
     }
    
    CepstrumAnalyzer a;
    Sample buf = new unsigned char[11025*20];
    unsigned size;
    unsigned dists[5];
    Pattern* p;

	// record
    cout << "<return> to start rec\n";
    getchar();
    cout << "recording... <return> to stop rec\n";
    size = 0;
    while( !crhit() && size < 11025*20) {
	read( fAudio, buf+size, 256 );
	size += 256;
    }
    
	// analyze
    cout << "Analyzing...\n";
    p = a.Analyze( buf, size );
    unsigned rcg = pdb.Recog( *p, dists );
    delete p;
    
    if( rcg == PATREFUSED )
	cout << "Pattern refused!";
     else
	 cout << "Recognized pattern: " << pdb[rcg].Name();
    cout << "\n\nDistances:\n";
    
    for( unsigned i = 0; i < pdb.nPatterns(); ++i)
	cout << pdb[i].Name() << ": " << dists[i] << endl;

    delete buf;
    close( fAudio );
}

