#include <unistd.h>		// read(), close()
#include <fcntl.h>		// O_RDONLY
#include <sys/soundcard.h>	// AFMT_U8
#include <sound.h>
#include "sprec.h"

void
printVec (Pattern::Vector vec, unsigned size)
{
    static int nCalled = 0;

    printf ("%i:", nCalled++);
    for (unsigned i = 0; i < size; ++i)
	printf (" %i", vec[i]);
    printf ("         \r");
    fflush (stdout);
}
    
int main ()
{
    int fAudio;
    unsigned char buf[256];
    Pattern::Element block[16];
    
    if ((fAudio = snd_initDevice (O_RDONLY, 11025, false, AFMT_U8, 8)) == -1)
     {
	 snd_perror ("snd_initDevice");
	 return -1;
     }

    CepstrumAnalyzer a;
    puts ("\n\n");
    while (1) {
	read (fAudio, buf, 256);
	
	a.AnalyzeWindow (buf, block);
	printVec (block, 16);
    }
    puts ("\n\n");

    close (fAudio);
}

